local TankOMeter, tom_table = ...


function tom_table.IniMainFrame()
	tom_table.frame = tom_table.CreateMyFrame("Tank-O-Meter", UIParent, "CENTER", tom_table.defaultX, tom_table.defaultY, tom_table.Settings.bWidth, tom_table.Settings.bHeight)
	tom_table.frame:SetUserPlaced(true)
	tom_table.frame:SetFrameStrata("MEDIUM")
	tom_table.frame:SetAlpha(tom_table.Settings.bAlpha)
	tom_table.frame.texture = tom_table.frame:CreateTexture(nil, "BACKGROUND")
	tom_table.frame.texture:SetAllPoints(true)
	tom_table.frame.texture:SetColorTexture(0, 0, 0, 0.3)
	tom_table.frame.title = tom_table.CreateLabel(tom_table.frame, 6, 0, "ChatFontNormal", tom_table.title, "CENTER", "TOP", tom_table.Settings.bWidth, tom_table.Settings.bHeight)
	tom_table.frame.tal = tom_table.CreateLabel(tom_table.frame, 4, 0, "ChatFontNormal", "TAL", "LEFT", "TOP", tom_table.Settings.bWidth, tom_table.Settings.bHeight)
	tom_table.frame.hal = tom_table.CreateLabel(tom_table.frame, 0, 0, "ChatFontNormal", "HAL", "RIGHT", "TOP", tom_table.Settings.bWidth, tom_table.Settings.bHeight)
        TOMConfigPanel:SetScale(1.3)
end

function tom_table.iniConfigPanel()
	tom_table.CPEditBox(TOMConfigPanelEditBoxTH1, "hanging lamp\nhealer mana threshold:\ngreen/yellow")
	tom_table.CPEditBox(TOMConfigPanelEditBoxTH2, "hanging lamp\nhealer mana threshold:\nyellow/red")
	tom_table.CPEditBox(TOMConfigPanelEditBoxBA1, "bar alpha")
        TOMConfigPanelEditBoxBA1:SetNumeric(false)
	tom_table.CPEditBox(TOMConfigPanelEditBoxBS1, "bar width")
	tom_table.CPEditBox(TOMConfigPanelEditBoxBS2, "bar height")
	tom_table.CPEditBox(TOMConfigPanelEditBoxFS1, "font size")

	TOMConfigPanelEditBoxTH1:SetScript("OnEnterPressed", function(self)
		tom_table.Settings.th1 = tonumber(self:GetText())
		if tom_table.Settings.th1 < 0 then tom_table.Settings.th1 = 0 end
		if tom_table.Settings.th1 > 100 then tom_table.Settings.th1 = 100 end
		tom_table.RefreshEditboxs()
		self:ClearFocus() -- clears focus from editbox, (unlocks key bindings, so pressing W makes your character go forward.
		TOMConfigPanelEditBoxTH2:SetFocus() -- if this is provided, previous line is not needed (opens chat frame)
		tom_table.hlstate()
	end)

	TOMConfigPanelEditBoxTH2:SetScript("OnEnterPressed", function(self)
		tom_table.Settings.th2 = tonumber(self:GetText())
		if tom_table.Settings.th2 < 0 then tom_table.Settings.th2 = 0 end
		if tom_table.Settings.th2 > 100 then tom_table.Settings.th2 = 100 end
		tom_table.RefreshEditboxs()
		self:ClearFocus() -- clears focus from editbox, (unlocks key bindings, so pressing W makes your character go forward.
		--TOMConfigPanelEditBoxTH1:SetFocus() -- if this is provided, previous line is not needed (opens chat frame)
		tom_table.hlstate()
	end)

	TOMConfigPanelEditBoxBA1:SetScript("OnEnterPressed", function(self)
		tom_table.Settings.bAlpha = tonumber(self:GetText())
		if tom_table.Settings.bAlpha < 0 then tom_table.Settings.bAlpha = 0 end
		if tom_table.Settings.bAlpha > 1 then tom_table.Settings.bAlpha = 1 end
		tom_table.RefreshEditboxs()
		self:ClearFocus() -- clears focus from editbox, (unlocks key bindings, so pressing W makes your character go forward.
		--TOMConfigPanelEditBoxBS2:SetFocus() -- if this is provided, previous line is not needed (opens chat frame)
		tom_table.Resizing()
                tom_table.UpdateBarRows()
	end)

	TOMConfigPanelEditBoxBS1:SetScript("OnEnterPressed", function(self)
		tom_table.Settings.bWidth = tonumber(self:GetText())
		if tom_table.Settings.bWidth < 100 then tom_table.Settings.bWidth = 100 end
		if tom_table.Settings.bWidth > 1000 then tom_table.Settings.bWidth = 1000 end
		tom_table.RefreshEditboxs()
		self:ClearFocus() -- clears focus from editbox, (unlocks key bindings, so pressing W makes your character go forward.
		TOMConfigPanelEditBoxBS2:SetFocus() -- if this is provided, previous line is not needed (opens chat frame)
		tom_table.Resizing()
                tom_table.UpdateBarRows()
	end)

	TOMConfigPanelEditBoxBS2:SetScript("OnEnterPressed", function(self)
		tom_table.Settings.bHeight = tonumber(self:GetText())
		if tom_table.Settings.bHeight < 10 then tom_table.Settings.bHeight = 10 end
		if tom_table.Settings.bHeight > 100 then tom_table.Settings.bHeight = 100 end
		tom_table.RefreshEditboxs()
		self:ClearFocus() -- clears focus from editbox, (unlocks key bindings, so pressing W makes your character go forward.
		TOMConfigPanelEditBoxFS1:SetFocus() -- if this is provided, previous line is not needed (opens chat frame)
		tom_table.Resizing()
                tom_table.UpdateBarRows()
	end)

	TOMConfigPanelEditBoxFS1:SetScript("OnEnterPressed", function(self)
		tom_table.Settings.fSize = tonumber(self:GetText())
		if tom_table.Settings.fSize < 8 then tom_table.Settings.fSize = 8 end
		if tom_table.Settings.fSize > 48 then tom_table.Settings.fSize = 48 end
		tom_table.RefreshEditboxs()
		self:ClearFocus() -- clears focus from editbox, (unlocks key bindings, so pressing W makes your character go forward.
		--TOMConfigPanelEditBoxTH1:SetFocus() -- if this is provided, previous line is not needed (opens chat frame)
		tom_table.Resizing()
                tom_table.UpdateBarRows()
	end)

	tom_table.CPToolTip(ToggleLOCK, tom_table.LockToolTip())

	local lfgTexture = "Interface\\LFGFRAME\\UI-LFG-ICON-ROLES"
	TOM_RoleIconTank:SetTexture(lfgTexture)
	TOM_RoleIconHealer:SetTexture(lfgTexture)
	TOM_RoleIconDD:SetTexture(lfgTexture)
	TOM_RoleIconTank:SetTexCoord(GetTexCoordsForRole("TANK"))
	TOM_RoleIconHealer:SetTexCoord(GetTexCoordsForRole("HEALER"))
	TOM_RoleIconDD:SetTexCoord(GetTexCoordsForRole("DAMAGER"))
        --TOMConfigPanel.bgFile:SetAllPoints(true)
end

function tom_table.IniBarRows()
	tom_table.RowN = 1 -- 1 = Titlebar with HAL
	tom_table.statusbarTankHealth = tom_table.CreateMyBars("TankHealth", tom_table.frame, 0, -tom_table.RowN*tom_table.Settings.bHeight, tom_table.Settings.bWidth, tom_table.Settings.bHeight, 1, 0.16, 0, 0.25, 0.04, 0) -- thp
	tom_table.RowN = tom_table.RowN + 1
	tom_table.statusbarHealerHealth = tom_table.CreateMyBars("HealerHealth", tom_table.frame, 0, -tom_table.RowN*tom_table.Settings.bHeight, tom_table.Settings.bWidth, tom_table.Settings.bHeight, 1, 1, 1, 0.25, 0.25, 0.25) -- hhp
	tom_table.RowN = tom_table.RowN + 1
	tom_table.statusbarHealerMana = tom_table.CreateMyBars("HealerMana", tom_table.frame, 0, -tom_table.RowN*tom_table.Settings.bHeight, tom_table.Settings.bWidth, tom_table.Settings.bHeight, 0, 0.6, 0.8, 0, 0.15, 0.2) -- hmp
	tom_table.RowN = tom_table.RowN + 1
	tom_table.statusbarGrpHealth = tom_table.CreateMyBars("GrpHealth", tom_table.frame, 0, -tom_table.RowN*tom_table.Settings.bHeight, tom_table.Settings.bWidth, tom_table.Settings.bHeight, 0.2, 1, 0.4, 0.05, 0.25, 0.1) -- ghp
	tom_table.RowN = tom_table.RowN + 1
	tom_table.statusbarGrpMana = tom_table.CreateMyBars("GrpMana", tom_table.frame, 0, -tom_table.RowN*tom_table.Settings.bHeight, tom_table.Settings.bWidth, tom_table.Settings.bHeight, 0.4, 0.6, 0.95, 0.1, 0.15, 0.21) -- gmp
end

function tom_table.IniHangingLamp()
	local wh = {64, 64}
	tom_table.hl = CreateFrame("Frame", "TOMHL", tom_table.frame)
	tom_table.hl:SetClampedToScreen(true)
	tom_table.hl:SetFrameStrata("LOW")
	tom_table.hl:SetFrameLevel(1)
	tom_table.hl:SetPoint("CENTER", tom_table.frame, "CENTER", 0, 25)
        tom_table.hl:SetParent(nil)
        tom_table.hl:SetScale(0.8)
	tom_table.hl:SetMovable(true)
	tom_table.hl:SetUserPlaced(true)
	tom_table.hl:SetSize(unpack(wh))
	tom_table.hl.texture = tom_table.hl:CreateTexture(nil, "BACKGROUND")
	tom_table.hl.texture:ClearAllPoints()
	tom_table.hl.texture:SetPoint("TOPLEFT")
	tom_table.hl.texture:SetTexture("Interface\\AddOns\\Tank-O-Meter\\textures\\tlw.blp")
	tom_table.HLColor("red")
	tom_table.hl:SetScript("OnMouseDown", function(self, button)
        	if button == "LeftButton" and (IsShiftKeyDown() or IsControlKeyDown() or IsAltKeyDown()) then
                        tom_table.SayPull()
		end
	end)
	tom_table.hl:SetScript("OnMouseUp", function(self, button)
	end)
end

function tom_table.IniHealerInRangeTexture()
	local w, h = 36, 36
        tom_table.HiRTexture = CreateFrame("Frame", "TOMHIR", tom_table.frame)
	tom_table.HiRTexture:SetFrameStrata("LOW")
	tom_table.HiRTexture:SetFrameLevel(12)
	tom_table.HiRTexture:SetPoint("TOPRIGHT", tom_table.hl, "TOPRIGHT", 0, 0)
	tom_table.HiRTexture:SetSize(w, h)
        tom_table.HiRTexture:SetParent(tom_table.hl)
        tom_table.HiRTexture:SetScale(0.5)
	tom_table.HiRTexture.texture1 = tom_table.HiRTexture:CreateTexture(nil, "OVERLAY", nil, 0)
	tom_table.HiRTexture.texture1:SetPoint("TOPLEFT", tom_table.HiRTexture, "TOPLEFT", 17, 10)
        tom_table.HiRTexture.texture1:SetTexture("Interface\\LFGFRAME\\UI-LFG-ICON-ROLES")
	tom_table.HiRTexture.texture1:SetTexCoord(GetTexCoordsForRole("HEALER"))
	tom_table.HiRTexture.texture1:SetSize(w-8, h-8)
	tom_table.HiRTexture.texture2 = tom_table.HiRTexture:CreateTexture(nil, "OVERLAY", nil, 2)
	tom_table.HiRTexture.texture2:SetPoint("TOPLEFT", tom_table.HiRTexture, "TOPLEFT", 14, 14)
        tom_table.HiRTexture.texture2:SetTexture("Interface\\PaperDollInfoFrame\\UI-GearManager-LeaveItem-Transparent")
	tom_table.HiRTexture.texture2:SetSize(w, h)
	tom_table.HiRTexture.texture3 = tom_table.HiRTexture:CreateTexture(nil, "OVERLAY", nil, 4)
	tom_table.HiRTexture.texture3:SetPoint("TOPLEFT", tom_table.HiRTexture, "TOPLEFT", -5, 5)
        tom_table.HiRTexture.texture3:SetTexture("Interface\\LFGFRAME\\BattlenetWorking2")
	tom_table.HiRTexture.texture3:SetSize(w+6, h+6)
end

function tom_table.IniTotemInRangeFrame()
	local wh = {48, 48}
	tom_table.TiRTexture = CreateFrame("Frame", "TOMTIR", tom_table.hl)
	tom_table.TiRTexture:SetFrameStrata("MEDIUM")
	tom_table.TiRTexture:SetFrameLevel(11)
	tom_table.TiRTexture:SetPoint("CENTER", tom_table.hl, "CENTER", 6, 3)
	tom_table.TiRTexture:SetSize(unpack(wh))
        tom_table.TiRTexture:SetParent(tom_table.hl)
        tom_table.TiRTexture:SetScale(0.8)
	tom_table.TiRTexture.texture = tom_table.TiRTexture:CreateTexture(nil, "OVERLAY")
	tom_table.TiRTexture.texture:SetPoint("TOPLEFT")
	tom_table.TiRTexture.texture:SetTexture("Interface\\AddOns\\Tank-O-Meter\\textures\\totem.blp")
	tom_table.TiRTexture.texture:SetVertexColor(1, 1, 1, 0.33)
	tom_table.TiRTexture.texture:SetSize(unpack(wh))
        tom_table.TiRTexture.Count = tom_table.TiRTexture:CreateFontString(nil, "OVERLAY", "NumberFontNormalYellow")
	tom_table.TiRTexture.Count:SetFont(tom_table.Font, tom_table.Settings.fSize, "OUTLINE")
	tom_table.TiRTexture.Count:SetPoint("TOP", tom_table.TiRTexture, "TOP", -4, 2)
	tom_table.TiRTexture.Count:SetAlpha(0.9)
        tom_table.HideShowFrame(tom_table.TiRTexture)

	tom_table.TiRTexture.tip = CreateFrame("GameTooltip", "TOMWETip", nil, "GameTooltipTemplate")
	tom_table.TiRTexture.tip:SetOwner(WorldFrame, "ANCHOR_NONE")
end

function tom_table.inibadpull()
	tom_table.bpf = tom_table.CreateMyFrame("Bad Pull", UIParent, "TOP", 0, -100, 100, 100)
	tom_table.bpf.texture = tom_table.bpf:CreateTexture(nil, "BACKGROUND")
	tom_table.bpf.texture:SetAllPoints(true)
	tom_table.bpf.texture:SetColorTexture(0, 0, 0, .5)

	tom_table.bpf2 = tom_table.CreateMyFrame("Bad Pull Texture", tom_table.bpf, "TOPLEFT", 0, 0, 100, 100)
	tom_table.bpf2.texture = tom_table.bpf2:CreateTexture(nil, "MEDIUM")
	tom_table.bpf2.texture:SetAllPoints(true)
	tom_table.bpf2.texture:SetTexture("Interface\\AddOns\\Tank-O-Meter\\textures\\badpull.blp")
	tom_table.bpf2.texture:SetAlpha(.5)
	tom_table.bpf:EnableMouse(false)
        tom_table.HideShowFrame(tom_table.bpf)
end

function tom_table.iniDEVframe()
	tom_table.DEVframe = tom_table.CreateMyFrame("TOM DEV Frame", UIParent, "CENTER", 0, 0, 300, 100)
	tom_table.DEVframe:SetMovable(true)
	tom_table.DEVframe:SetUserPlaced(true)
	tom_table.DEVframe.texture = tom_table.DEVframe:CreateTexture(nil, "BACKGROUND")
	tom_table.DEVframe.texture:SetAllPoints(true)
	tom_table.DEVframe.texture:SetColorTexture(0, 0, 0, .5)
	tom_table.DEVframe.txt1 = tom_table.iniDEVframeLabels(1)
	tom_table.DEVframe.txt1:SetFont(tom_table.Font, tom_table.Settings.fSize+2, "OUTLINE")
	tom_table.DEVframe.txt1:SetTextColor(0, 1, 0)
	tom_table.DEVframe.txt2 = tom_table.iniDEVframeLabels(2)
	tom_table.DEVframe.txt3 = tom_table.iniDEVframeLabels(3)
	tom_table.DEVframe.txt4 = tom_table.iniDEVframeLabels(4)
	tom_table.DEVframe.txt5 = tom_table.iniDEVframeLabels(5)
        tom_table.DEVframe:Show()
	tom_table.DragFrame(tom_table.DEVframe)
end

function tom_table.iniDEVframeLabels(line)
	local x = ((line - 1) * -20) - 3
	local label = tom_table.DEVframe:CreateFontString(nil, "OVERLAY")
	label:SetPoint("TOP", tom_table.DEVframe, "TOP", 0, x)
	label:SetFont(tom_table.Font, tom_table.Settings.fSize, "OUTLINE")
	label:SetJustifyH("CENTER")
	label:SetShadowOffset(1, -1)
	label:SetTextColor(1, 1, 1)
	label:SetText("Tank-O-Meter DEV Frame")
	return label
end

function tom_table.UpdateInfoOnce(...)
	local bypass = ...
	if (tom_table.once == 0) or (tom_table.tocversion ~= tom_table.version) or bypass then
		local MessageFrame = CreateFrame("Frame", nil, UIParent, "BasicFrameTemplate")
		MessageFrame:SetFrameLevel(20)
		MessageFrame:SetSize(420, 330)
		MessageFrame:SetPoint("CENTER")
		MessageFrame:EnableMouse(true)
		MessageFrame:SetMovable(true)
		MessageFrame:RegisterForDrag("LeftButton")
		MessageFrame:SetScript("OnDragStart", MessageFrame.StartMoving)
		MessageFrame:SetScript("OnDragStop", MessageFrame.StopMovingOrSizing)
                MessageFrame.s = CreateFrame("ScrollFrame", nil, MessageFrame, "UIPanelScrollFrameTemplate") -- or you actual parent instead
		MessageFrame.s:SetPoint("TOPLEFT", 5, -25)
		MessageFrame.s:SetSize(387,300)
                MessageFrame.inside = CreateFrame("Frame", nil, MessageFrame)
		MessageFrame.inside:SetPoint("TOPLEFT", 0, 0)
		MessageFrame.inside:SetSize(420,320)
		MessageFrame.title = tom_table.CreateLabel(MessageFrame, 10, -4, "ChatFontNormal", tom_table.title.." "..tom_table.version, "LEFT", "TOP", 0, 0)
		MessageFrame.message = tom_table.CreateLabel(MessageFrame.inside, 0, 0, "GameFontNormal", tom_table.TOM_Changings, "LEFT", "TOP", 390, 1000)
                MessageFrame.message:SetJustifyV("TOP")
		MessageFrame.message:SetFont(tom_table.Font, 14, "OUTLINE")
		MessageFrame.s:SetScrollChild(MessageFrame.inside)
                tom_table.HideShowFrame(MessageFrame, true)
	      	tom_table.once = tom_table.version
                if not bypass then tom_table.ShowTOMCP() end
	end
end

function tom_table.IniListsFrame()
	tom_table.ListsFrame = CreateFrame("Frame", nil, UIParent, "BasicFrameTemplate")
	tom_table.ListsFrame:SetFrameLevel(20)
	tom_table.ListsFrame:SetSize(420, 330)
	tom_table.ListsFrame:SetPoint("CENTER")
        tom_table.ListsFrame:SetScale(1.3)
	tom_table.ListsFrame:EnableMouse(true)
	tom_table.ListsFrame:SetMovable(true)
	tom_table.ListsFrame:RegisterForDrag("LeftButton")
	tom_table.ListsFrame:SetScript("OnDragStart", tom_table.ListsFrame.StartMoving)
	tom_table.ListsFrame:SetScript("OnDragStop", tom_table.ListsFrame.StopMovingOrSizing)
	tom_table.ListsFrame.title = tom_table.CreateLabel(tom_table.ListsFrame, 10, -4, "ChatFontNormal", tom_table.title.." tank & healer lists", "LEFT", "TOP", 0, 0)
	tom_table.ListsFrame.messageLeft = tom_table.CreateLabel(tom_table.ListsFrame, 10, -25, "GameFontNormal", "Tanks", "LEFT", "TOP", 170, 30)
	tom_table.ListsFrame.messageRight = tom_table.CreateLabel(tom_table.ListsFrame, 220, -25, "GameFontNormal", "Healer", "LEFT", "TOP", 170, 30)
	tom_table.ListsFrame.messageLeft:SetFont(tom_table.Font, 14, "OUTLINE")
	tom_table.ListsFrame.messageRight:SetFont(tom_table.Font, 14, "OUTLINE")
        tom_table.ListsFrame.tanks = tom_table.createEditBox("Tanks", tom_table.ListsFrame, 10, -40, 170, 280, displayname)
        tom_table.ListsFrame.healer = tom_table.createEditBox("Healer", tom_table.ListsFrame, 220, -40, 170, 280, displayname)
	tom_table.HideShowFrame(tom_table.ListsFrame)
end

function tom_table.IniMenu()
	tom_table.menuFrame = CreateFrame("Frame", "TOM_MenuFrame", UIParent, "UIDropDownMenuTemplate")
end