local TankOMeter, tom_table = ...

function tom_table.Bars(unitID)
	local bartable = { tanks = { health = 0, maxhealth = 0, mana = 0, maxmana = 0, reg = 0, infight = 0, totem = 0, manatotem = 0, airtotem = 0}, healer = { health = 0, maxhealth = 0, mana = 0, maxmana = 0, reg = 0, infight = 0, totem = 0, manatotem = 0, airtotem = 0}, group = { health = 0, maxhealth = 0, mana = 0, maxmana = 0, reg = 0, infight = 0, totem = 0, manatotem = 0, airtotem = 0}}
	local uReg, uInfight, uInTotem, uHealth, uMaxHealth, uHealthPerc, uMana, uMaxMana, uManaPerc, uRole, InRange
	local uName = "player"
	local PoGs = tom_table.PoGSoloShort
	local PoG = tom_table.PoGSolo

	if IsInRaid() then
		PoGs = tom_table.PoGRaidShort
		PoG = tom_table.PoGRaid
	elseif IsInGroup() then
		PoGs = tom_table.PoGPartyShort
		PoG = tom_table.PoGParty
	end

	uHealth = UnitHealth(uName)
	uMaxHealth = UnitHealthMax(uName)
	uReg, uInfight, uInTotem, uManaTotem, uAirTotem = tom_table.getBuffs(uName)
	uRole = tom_table.UnitRole(uName)
	uRole = uRole == 0 and "group" or uRole == 1 and "healer" or uRole == 2 and "tanks"
	bartable[uRole].health = bartable[uRole].health + uHealth
	bartable[uRole].maxhealth = bartable[uRole].maxhealth + uMaxHealth
	bartable[uRole].reg = bartable[uRole].reg + uReg
	bartable[uRole].infight = bartable[uRole].infight + uInfight
	bartable[uRole].totem = bartable[uRole].totem + uInTotem
	bartable[uRole].manatotem = bartable[uRole].manatotem + uManaTotem
	bartable[uRole].airtotem = bartable[uRole].airtotem + uAirTotem

        if UnitPowerType(uName) == 0 then
		uMana = UnitPower(uName)
		uMaxMana = UnitPowerMax(uName, 0)
		bartable[uRole].mana = bartable[uRole].mana + uMana
		bartable[uRole].maxmana = bartable[uRole].maxmana + uMaxMana
	end

	tom_table.OneHealerIsInRange = (tom_table.isHealer(UnitName(uName)) == 1) and 1 or 0

	for i = 1, GetNumGroupMembers() do
		uName = tom_table.BuildUnitID(i)
		if UnitName(uName) ~= UnitName("player") then
			if tom_table.isHealer(UnitName(uName)) == 1 then
				InRange = UnitInRange(uName) and 1 or 0
				tom_table.OneHealerIsInRange = tom_table.OneHealerIsInRange + InRange
			end
			uHealth = UnitHealth(uName)
			uMaxHealth = UnitHealthMax(uName)
			uReg, uInfight, uInTotem = tom_table.getBuffs(uName)
			uRole = tom_table.UnitRole(uName)
			uRole = uRole == 0 and "group" or uRole == 1 and "healer" or uRole == 2 and "tanks"
			bartable[uRole].health = bartable[uRole].health + uHealth
			bartable[uRole].maxhealth = bartable[uRole].maxhealth + uMaxHealth
			bartable[uRole].reg = bartable[uRole].reg + uReg
			bartable[uRole].infight = bartable[uRole].infight + uInfight
			bartable[uRole].totem = bartable[uRole].totem + uInTotem
			bartable[uRole].manatotem = bartable[uRole].manatotem + uManaTotem
			bartable[uRole].airtotem = bartable[uRole].airtotem + uAirTotem
		        if UnitPowerType(uName) == 0 then
				uMana = UnitPower(uName)
				uMaxMana = UnitPowerMax(uName, 0)
				bartable[uRole].mana = bartable[uRole].mana + uMana
				bartable[uRole].maxmana = bartable[uRole].maxmana + uMaxMana
			end
		end
	end

	tom_table.ValueToBar("statusbarTankHealth", "Tank health pool ", tom_table.thpTxt, bartable.tanks.maxhealth, bartable.tanks.health, nil, bartable.tanks.infight, bartable.tanks.totem, bartable.tanks.airtotem)
	tom_table.ValueToBar("statusbarHealerHealth", "Healer health pool ", tom_table.hhpTxt, bartable.healer.maxhealth, bartable.healer.health, nil, bartable.healer.infight, bartable.healer.totem, bartable.healer.manatotem)
	tom_table.ValueToBar("statusbarHealerMana", "Healer mana pool ", tom_table.hmpTxt, bartable.healer.maxmana, bartable.healer.mana, bartable.healer.reg, nil, bartable.healer.totem, nil)
	tom_table.ValueToBar("statusbarGrpHealth", PoG.."health ", PoGs..tom_table.ghpTxt, bartable.group.maxhealth, bartable.group.health, nil, bartable.group.infight, bartable.group.totem, nil)
	tom_table.ValueToBar("statusbarGrpMana", PoG.."health ", PoGs..tom_table.gmpTxt, bartable.group.maxmana, bartable.group.mana, bartable.group.reg, nil, bartable.group.totem, nil)

	tom_table.UpdateBarRows()
end

function tom_table.ValueToBar(bar, tooltip, txtLeft, maxValue, value, reg, infight, totem, totemcolor)
	if maxValue ~= 0 then
        	local percent = (maxValue ~= 0) and (maxValue == value) and 100 or floor(value / (maxValue / 100)) or 0
		tom_table[bar].value:SetText(txtLeft)
		tom_table[bar].value2:SetText(percent.."%")
		tom_table[bar]:SetMinMaxValues(0, maxValue)
		tom_table[bar]:SetValue(value)
		tom_table[bar].tooltip = tooltip..percent.."% ("..value.."/"..maxValue..")"
                tom_table[bar].precent = percent
	else
		tom_table[bar].value:SetText("")
		tom_table[bar].value2:SetText("")
		tom_table[bar]:SetMinMaxValues(0,0)
		tom_table[bar]:SetValue(0)
		tom_table[bar].tooltip = (bar == "statusbarTankHealth") and "no Tank added" or (bar == "statusbarHealerHealth" or bar == "statusbarHealerMana") and "no Healer added" or "go, find a group!"

                tom_table[bar].precent = 0
	end

	tom_table[bar]:SetScript("OnEnter", (tom_table.BarToolTipStatus) and tom_table.OnEnterFrame or nil)
	tom_table[bar]:SetScript("OnLeave", (tom_table.BarToolTipStatus) and tom_table.OnLeaveFrame or nil)

	tom_table[bar]:EnableMouse(tom_table.BarToolTipStatus)
        tom_table.ShowStatusBuff(bar, "reg", reg, totem, totemcolor)
        tom_table.ShowStatusBuff(bar, "infight", infight, totem, totemcolor)
end

function tom_table.ShowStatusBuff(bar, tab, statusbuff, totem, totemcolor)
	if statusbuff ~= nil then
		tom_table.HideShowFrame(tom_table[bar][tab].texture, statusbuff) -- show reg texture

		if tab == "infight" then -- show totem texture
			tom_table.HideShowFrame(tom_table[bar].totem.texture, totem)
                	if totem == 0 then totem = "" end
			if totemcolor ~= 0 and bar == "statusbarTankHealth" then
				tom_table[bar].totem.texture:SetVertexColor(1, 0, 0, 1)
			elseif totemcolor ~= 0 and bar == "statusbarHealerHealth" then
				tom_table[bar].totem.texture:SetVertexColor(0, 0.5, 1, 1)
			else
				tom_table[bar].totem.texture:SetVertexColor(1, 1, 0, 1)
			end
			tom_table[bar].totem.texture.count:SetText(totem)
		end

		if statusbuff == 0 then statusbuff = "" end
		tom_table[bar][tab].texture.count:SetText(statusbuff)
	end
end

function tom_table.UpdateBarRows()
	local RowN, a, b, tCount, hCount, gCount = 0, 0, 0, tom_table.CountTanks("grp"), tom_table.CountHealer("grp"), tom_table.CountGroup()
------ Tank bar
	if tom_table.THPstatus and tCount ~= 0 then
		RowN = RowN + 1
		tom_table.statusbarTankHealth:SetPoint("TOPLEFT", 0, -RowN*tom_table.Settings.bHeight-2)
		a = 2
	end

------ Healer bars
	if tom_table.HHPstatus and hCount ~= 0 then
		RowN = RowN + 1
		tom_table.statusbarHealerHealth:SetPoint("TOPLEFT", 0, -RowN*tom_table.Settings.bHeight-2-a)
	end

	if tom_table.HMPstatus and hCount ~= 0 then
		RowN = RowN + 1
		tom_table.statusbarHealerMana:SetPoint("TOPLEFT", 0, -RowN*tom_table.Settings.bHeight-2-a)
	end

	if (tom_table.HHPstatus and hCount ~= 0) or (tom_table.HMPstatus and hCount ~= 0) then
		b = 2
	end

------ Group bars
	if tom_table.GHPstatus and gCount ~= 0 then
		RowN = RowN + 1
		tom_table.statusbarGrpHealth:SetPoint("TOPLEFT", 0, -RowN*tom_table.Settings.bHeight-2-a-b)
	end

	if tom_table.GMPstatus and gCount ~= 0 then
		RowN = RowN + 1
		tom_table.statusbarGrpMana:SetPoint("TOPLEFT", 0, -RowN*tom_table.Settings.bHeight-2-a-b)
	end

        tom_table.HideShowFrame(tom_table.frame, tom_table.FrameStatus)
        tom_table.HideShowFrame(tom_table.hl, tom_table.hlStatus)
        tom_table.HideShowFrame(tom_table.TarFrame, tom_table.Settings.TOHstatus)
        tom_table.HideShowFrame(tom_table.frame.hal, tom_table.HALstatus)
        tom_table.HideShowFrame(tom_table.frame.tal, tom_table.TALstatus)

        tom_table.IsBarInUse(tom_table.statusbarTankHealth, tCount, tom_table.THPstatus)
        tom_table.IsBarInUse(tom_table.statusbarHealerHealth, hCount, tom_table.HHPstatus)
        tom_table.IsBarInUse(tom_table.statusbarHealerMana, hCount, tom_table.HMPstatus)
        tom_table.IsBarInUse(tom_table.statusbarGrpHealth, gCount, tom_table.GHPstatus)
        tom_table.IsBarInUse(tom_table.statusbarGrpMana, gCount, tom_table.GMPstatus)
end

function tom_table.IsBarInUse(bar, counter,  barStatus)
	if counter == 0 then
        	tom_table.HideShowBar(bar)
	else
        	tom_table.HideShowBar(bar, barStatus)
	end
end

function tom_table.BarCounter()
	local count = 1 -- 1 = Titlebar with HAL
	if tom_table.THPstatus then count = count + 1 end
	if tom_table.HHPstatus then count = count + 1 end
	if tom_table.HMPstatus then count = count + 1 end
	if tom_table.GHPstatus then count = count + 1 end
	if tom_table.GMPstatus then count = count + 1 end
	return count
end

function tom_table.HealerInRangeTexture(OIstate)
	tom_table.HideShowFrame(tom_table.HiRTexture, OIstate)
end

function tom_table.TAL()
	local a = tom_table.CountTanks()
	local g = tom_table.CountTanks("grp")
	local l = tom_table.CountTanks("list")

	tom_table.frame.tal:SetText(g.."/"..a.."/"..l)
end

function tom_table.HAL()
	local a = tom_table.CountHealer()
	local g = tom_table.CountHealer("grp")
	local l = tom_table.CountHealer("list")

	tom_table.frame.hal:SetText(g.."/"..a.."/"..l)
end