local TankOMeter, tom_table = ...
local eventCountTable = {}
SLASH_tomet1 = "/tomet"
SLASH_tometlock1 = "/tometlock"
SLASH_tometaddtank1 = "/tometaddtank"
SLASH_tometaddheal1 = "/tometaddheal"
SLASH_tometremove1 = "/tometremove"
SLASH_tometremove2 = "/tometrem"
SLASH_tometlisttanks1 = "/tometlisttanks"
SLASH_tometlisthealer1 = "/tometlisthealer"
SLASH_tometlists1 = "/tometlists"
SLASH_tometclearlist1 = "/tometclearlist"
SLASH_tometpull1 = "/tometpull"
SLASH_tometlog1 = "/tometlog"

tom_table.eventFrame = CreateFrame("Frame")
tom_table.ChangeEvents = {"PLAYER_ENTERING_WORLD", "UNIT_HEALTH", "UNIT_MAXHEALTH", "UNIT_POWER_UPDATE", "UNIT_MAXPOWER", "PLAYER_STOPPED_MOVING"} --, "COMBAT_LOG_EVENT_UNFILTERED"
tom_table.SpecialEvents = {"ADDON_LOADED", "PLAYER_LOGOUT", "MODIFIER_STATE_CHANGED", "GROUP_ROSTER_UPDATE", "RAID_ROSTER_UPDATE", "PLAYER_EQUIPMENT_CHANGED", "UNIT_AURA", "PLAYER_STARTED_MOVING", "BAR_UPDATE"}
tom_table.eventFrame:RegisterEvent("ADDON_LOADED") -- Fired when saved variables are loaded

function tom_table.LoadVarsAndDefaults()
	tom_table.Settings		= (TankOMeter_Settings == nil)			and {}		or TankOMeter_Settings
	tom_table.CharSettings		= (TankOMeter_CharSettings == nil)		and {}		or TankOMeter_CharSettings
	tom_table.Settings.dev		= (tom_table.Settings.dev == nil)		and nil		or tom_table.Settings.dev
	tom_table.Settings.bAlpha	= (tom_table.Settings.bAlpha == nil)		and 0.77	or tom_table.Settings.bAlpha
	tom_table.Settings.bWidth	= (tom_table.Settings.bWidth == nil)		and 250		or tom_table.Settings.bWidth
	tom_table.Settings.bHeight	= (tom_table.Settings.bHeight == nil)		and 18		or tom_table.Settings.bHeight
	tom_table.Settings.fSize	= (tom_table.Settings.fSize == nil)		and 14		or tom_table.Settings.fSize
	tom_table.Settings.th1		= (tom_table.Settings.th1 == nil)		and 90		or tom_table.Settings.th1                       -- threshold green / yellow
	tom_table.Settings.th2		= (tom_table.Settings.th2 == nil)		and 30		or tom_table.Settings.th2
	tom_table.Settings.Healer	= (tom_table.Settings.Healer == nil)		and ((TankOMeter_Healer == nil) and {} or TankOMeter_Healer) or tom_table.Settings.Healer
	tom_table.Settings.Tanks	= (tom_table.Settings.Tanks == nil)		and ((TankOMeter_Tanks == nil) and {} or TankOMeter_Tanks) or tom_table.Settings.Tanks                       -- threshold green / yellow
	tom_table.Settings.TOHstatus	= (tom_table.Settings.TOHstatus == nil)		and true	or tom_table.Settings.TOHstatus

	tom_table.CharSettings.myRoleIs	= (tom_table.CharSettings.myRoleIs == nil) 	and false	or tom_table.CharSettings.myRoleIs

	tom_table.once			= (TankOMeter_once == nil)			and 0		or TankOMeter_once
	tom_table.InfightStatus		= UnitAffectingCombat("player")			and 0		or 1
	tom_table.FrameStatus		= (TankOMeter_FrameStatus == nil)		and true	or TankOMeter_FrameStatus
	tom_table.hlStatus		= (TankOMeter_hlStatus == nil)			and true	or TankOMeter_hlStatus
	tom_table.FrameLOCKstatus	= (TankOMeter_FrameDragStatus == nil)		and true	or TankOMeter_FrameDragStatus
	tom_table.FrameLOCKToolTip	= ""
	tom_table.BarToolTipStatus	= (TankOMeter_BarToolTip == nil)		and true	or TankOMeter_BarToolTip
	tom_table.SYNCstatus		= (TankOMeter_SYNCstatus == nil)		and true	or TankOMeter_SYNCstatus

	tom_table.BPstatus		= (TankOMeter_BPstatus == nil)			and true	or TankOMeter_BPstatus
	tom_table.TALstatus		= (TankOMeter_TALstatus == nil)			and true	or TankOMeter_TALstatus
	tom_table.HALstatus		= (TankOMeter_HALstatus == nil)			and true	or TankOMeter_HALstatus
	tom_table.HHPstatus		= (TankOMeter_HHPstatus == nil)			and true	or TankOMeter_HHPstatus
	tom_table.HMPstatus		= (TankOMeter_HMPstatus == nil)			and true	or TankOMeter_HMPstatus
	tom_table.GHPstatus		= (TankOMeter_GHPstatus == nil)			and true	or TankOMeter_GHPstatus
	tom_table.GMPstatus		= (TankOMeter_GMPstatus == nil)			and true	or TankOMeter_GMPstatus
	tom_table.THPstatus		= (TankOMeter_THPstatus == nil)			and true	or TankOMeter_THPstatus
	tom_table.Sound			= (TankOMeter_Sound == nil)			and true	or TankOMeter_Sound

	tom_table.title			= GetAddOnMetadata("Tank-O-Meter", "Title")
	tom_table.Author		= GetAddOnMetadata("Tank-O-Meter", "Author")
	tom_table.tocversion		= tonumber(GetAddOnMetadata("Tank-O-Meter", "Version"))
	tom_table.version		= 2004041728
	tom_table.anchor		= "LEFT"
	tom_table.defaultX		= 321
	tom_table.defaultY		= 95
	tom_table.Font			= "Interface\\AddOns\\Tank-O-Meter\\fonts\\FORCED SQUARE.ttf"  -- standard -> "FRIZQT__.TTF"
	tom_table.thpTxt		= "T.HP: "
	tom_table.hhpTxt		= "H.HP: "
	tom_table.hmpTxt		= "H.MP: "
	tom_table.PoGSoloShort		= "S."
	tom_table.PoGRaidShort		= "R."
	tom_table.PoGPartyShort		= "P."
	tom_table.PoGSolo		= "Solo "
	tom_table.PoGRaid		= "Raid "
	tom_table.PoGParty		= "Party "
	tom_table.gmpTxt		= "MP: "
	tom_table.ghpTxt		= "HP: "
	tom_table.BPonce		= 0
	tom_table.OneHealerIsInRange	= 0
	tom_table.BarUpdateSpeed	= 1 / 8
	tom_table.LastBarUpdate		= GetTime()

--------------------------------Targets-----------------------------------------
	tom_table.TarGUID		= {}
	tom_table.TarSet		= {}
	tom_table.TarSet.title		= "|cFFFF0084Target|r-|cFF33FF33O|r-|cFFFF0084History|r"
	tom_table.TarSet.timeout	= 20
	tom_table.TarSet.maxtar		= 15
	tom_table.TarSet.anchor		= "RIGHT"
	tom_table.TarSet.defaultX	= -321
	tom_table.TarSet.defaultY	= 95
--------------------------------Targets-----------------------------------------

-----------------------------SpecDetection--------------------------------------
        tom_table.ClassesNSpecs		= {
		deathknight = { healer = { false }, tank = { false }}, -- deathknight xDDD
		druid = { tank = {"Feral Combat"}, healer = {"Restoration"}},
		hunter = { healer = { false }, tank = { false }},
		mage = { healer = { false }, tank = { false }},
		paladin = { tank = {"Protection"}, healer = {"Holy"}},
		priest = { healer = {"Discipline", "Holy"}, tank = { false }},
		rogue = { healer = { false }, tank = { false }},
		shaman = { healer = {"Restoration"}, tank = { false }},
		warlock = { healer = { false }, tank = { false }},
		warrior = { healer = { false }, tank = {"Protection", "Fury", "Arms"}}
	}
        tom_table.MinSkillPoints        = 30
-----------------------------SpecDetection--------------------------------------

-----------------------------TotemDetector--------------------------------------
	tom_table.TotemIDs = {
		FlametongueWeapon = 8024,
		FrostbrandWeapon = 8033,
		RockbiterWeapon = 8017,
		WindfuryWeapon = 8232,

		FireNova = 1535,
		Flametongue = 8227,
		FrostResistance = 8181,
		Magma = 8190,
		Searing = 3599,

		EarthBind = 2484,
		Stoneclaw = 5730,
		Stoneskin = 8071,
		StrengthOfEarth = 8075,
		Tremor = 8143,

		DiseaseCleansing = 8170,
		FireResistance = 8184,
		HealingStream = 5394,
		ManaSpring = 5675,
		ManaTide = 16190,
		PoisonCleansing = 8166,

		GraceOfAir = 8835,
		Grounding = 8177,
		NatureResistance = 10595,
		Sentry = 6495,
		TranquilAir = 25908,
		Windfury = 8512,
		Windwall = 15107,
	}

	tom_table.TotemTextures = {}
	tom_table.TotemNames = {}
        tom_table.NameToTotemID = {}
        tom_table.TCheck = 0
        tom_table.TWCheck = 0

	for _,v in pairs(tom_table.TotemIDs) do
		tom_table.TotemNames[v] = select(1, GetSpellInfo(v))
		tom_table.TotemTextures[v] = select(3, GetSpellInfo(v))
		if v and tom_table.TotemNames[v] then tom_table.NameToTotemID[tom_table.TotemNames[v]] = v end
	end
-----------------------------TotemDetector--------------------------------------
end

tom_table.eventFrame:SetScript("OnEvent", function(self, event, ...)
	if tom_table.Settings and tom_table.Settings.dev and tom_table.DEVframe then
		tom_table.DEVframe.txt2:SetText(GetTime()..": "..event)
                tom_table.EventPerSecond("events", tom_table.DEVframe.txt3, " / EPS unfiltered")
	end

	if event == "UPDATE_MOUSEOVER_UNIT" or event == "PLAYER_TARGET_CHANGED" then
        	tom_table.UpdateTarBars(event) --Targets------------------------
                tom_table.hlstate()
		return
	end

        if tom_table.IsInTable(tom_table.ChangeEvents, event) then event = "BAR_UPDATE"	end
	if tom_table.IsInTable(tom_table.SpecialEvents, event) then tom_table.eventFrame[event](self, ...) end -- call event handlers
	tom_table.hlstate()
end)

function showme()
	print(dump(TankOMeter))
end

function tom_table.eventFrame:PLAYER_EQUIPMENT_CHANGED()
	C_Timer.After(0.5, function()
		tom_table.Bars()
		tom_table.TAL()
		tom_table.HAL()
		tom_table.BadPullNotification()
	end)
end

function tom_table.eventFrame:UNIT_AURA()
	tom_table.Bars()
	tom_table.TAL()
	tom_table.HAL()
	tom_table.BadPullNotification()
end

function tom_table.eventFrame:GROUP_ROSTER_UPDATE()
	tom_table.syncLists()
	tom_table.Bars()
	tom_table.TAL()
	tom_table.HAL()
	tom_table.BadPullNotification()
end

function tom_table.eventFrame:RAID_ROSTER_UPDATE()
	tom_table.syncLists()
	tom_table.Bars()
	tom_table.TAL()
	tom_table.HAL()
	tom_table.BadPullNotification()
end

function tom_table.eventFrame:PLAYER_STARTED_MOVING()
	tom_table.Bars()
	tom_table.TAL()
	tom_table.HAL()
	tom_table.BadPullNotification()
end

function tom_table.eventFrame:BAR_UPDATE(unitID)
	if tom_table.DEVframe then tom_table.EventPerSecond("bars1", tom_table.DEVframe.txt4, " / EPS before hand breaked") end
----------- fps break ----------------------------------------------------------
	local framerate = floor(GetFramerate())
      	if framerate < 60 then return end
----------- hand break ---------------------------------------------------------
	if tom_table.PlayerIsIn() ~= "solo" or IsResting() then
		local timestamp = GetTime()
		if not tom_table.LastBarUpdate then tom_table.LastBarUpdate = timestamp end
		if timestamp < (tom_table.LastBarUpdate + tom_table.BarUpdateSpeed) then return end
	end
----------- hand break ---------------------------------------------------------
	if tom_table.DEVframe then tom_table.EventPerSecond("bars2", tom_table.DEVframe.txt5, " / EPS hand breaked") end

	tom_table.Bars(unitID)
	tom_table.TAL()
	tom_table.HAL()
	tom_table.BadPullNotification()
	tom_table.LastBarUpdate = timestamp
end

function tom_table.eventFrame:ADDON_LOADED(AddOn)
	if AddOn ~= TankOMeter then
		return -- not my AddOn
	end
	-- usually, the first thing you do here is Unregister ADDON_LOADED because you no longer need it
	-- run once

	tom_table.LoadVarsAndDefaults()
	tom_table.eventhandles()
	tom_table.IniMainFrame()
	tom_table.IniBarRows()
	tom_table.IniHangingLamp()
        tom_table.IniHealerInRangeTexture()
        tom_table.IniTotemInRangeFrame()
	tom_table.inibadpull()
	tom_table.IniTarFrame()
	tom_table.DragFrameMaster()
	tom_table.iniConfigPanel()
        tom_table.IniListsFrame()
	tom_table.IniMenu()
	hooksecurefunc("UnitPopup_ShowMenu", tom_table.UnitPopup_ShowMenu)
	TOMConfigPaneltitle:SetFont(tom_table.Font, tom_table.Settings.fSize+2, "OUTLINE")
        tom_table.synchandles()
	tom_table.UpdateInfoOnce()
	if tom_table.Settings.dev then
                tom_table.iniDEVframe()
	end
	tom_table.Bars()
	tom_table.TAL()
	tom_table.HAL()
        tom_table.TotemCheck()
end

function tom_table.EPS(identName, ...)
	local cleanup = ...
	local timestamp = GetTime()
	local i = 0
	local t = cleanup and nil or true
        --tom_table.DEVframe.txt5:SetText(t.." / cleanup")
        if not eventCountTable[identName] then eventCountTable[identName] = {} end
	if not cleanup then table.insert(eventCountTable[identName], timestamp) end
	for k, v in pairs(eventCountTable[identName]) do
		if timestamp >= (v + 1) then table.remove(eventCountTable[identName], k) end
	end
	for _ in pairs(eventCountTable[identName]) do i = i + 1 end
	return i
end

function tom_table.EventPerSecond(name, frame, txt)
	if tom_table.Settings.dev then
		frame:SetText(tom_table.EPS(name)..txt)
		C_Timer.After(1, function()
			frame:SetText(tom_table.EPS(name, true)..txt)
		end)
	end
end

function tom_table.eventhandles()
	tom_table.eventFrame:UnregisterEvent("ADDON_LOADED")
	tom_table.eventFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
	tom_table.eventFrame:RegisterEvent("PLAYER_LOGOUT")
	tom_table.eventFrame:RegisterEvent("GROUP_ROSTER_UPDATE")
	tom_table.eventFrame:RegisterEvent("RAID_ROSTER_UPDATE")
	tom_table.eventFrame:RegisterEvent("UNIT_HEALTH")
	tom_table.eventFrame:RegisterEvent("UNIT_MAXHEALTH")
	tom_table.eventFrame:RegisterEvent("UNIT_POWER_UPDATE")
	tom_table.eventFrame:RegisterEvent("UNIT_MAXPOWER")
	tom_table.eventFrame:RegisterEvent("UNIT_AURA")
	tom_table.eventFrame:RegisterEvent("UNIT_INVENTORY_CHANGED")
        tom_table.eventFrame:RegisterEvent("BAG_UPDATE")
	tom_table.eventFrame:RegisterEvent("PLAYER_TOTEM_UPDATE")
	tom_table.eventFrame:RegisterEvent("MODIFIER_STATE_CHANGED")
	tom_table.eventFrame:RegisterEvent("UPDATE_MOUSEOVER_UNIT")
	tom_table.eventFrame:RegisterEvent("PLAYER_TARGET_CHANGED")
	tom_table.eventFrame:RegisterEvent("PLAYER_STARTED_MOVING")
	tom_table.eventFrame:RegisterEvent("PLAYER_STOPPED_MOVING")
	tom_table.eventFrame:RegisterEvent("PLAYER_EQUIPMENT_CHANGED")
--------------------------------Targets-----------------------------------------
	tom_table.ToggleTARHISTORYevents()
--------------------------------Targets-----------------------------------------

end

function tom_table.HideShowFrame(parent, state)
        if type(state) == "number" then	if state == 0 then state = nil else state = true end end
	if parent ~= nil and parent ~= UIParent then
		if state and not parent:IsShown() then
			parent:Show()
			--print("show")
		elseif not state and parent:IsShown() then
			parent:Hide()
			--print("hide")
		end
		--print(dump(parent))
	end
end

function tom_table.OnEnterFrame(self)
	GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
	GameTooltip:SetText(self.tooltip, nil, nil, nil, nil, true)
        GameTooltip:Show()
end

function tom_table.OnLeaveFrame()
        GameTooltip:Hide()
end

function tom_table.PrintMSG(msg)
	DEFAULT_CHAT_FRAME:AddMessage(tom_table.title.." "..msg, 0.3, 1, 0.3, nil, true);
	if tom_table.Settings.dev then
		tom_table.DEVframe.txt5:SetText(msg)
	end
end

function tom_table.getBuffs(UnitID)
	local reg = 0
	local totem, manatotem, airtotem = 0, 0, 0
        local buffed
	for i=1,40 do
		buffed = select(1, UnitAura(UnitID,i))
		if buffed then
			-- print(buffed)
			-- Drink 132805 0 nil 30 412639.16 player false false 22734 false false true false 1
			-- Drink 132794 0 nil 30 580777.423 player false false 1137 false false true false 1
			local totemID = tom_table.NameToTotemID[buffed.." Totem"]
			if totemID then
				totem = 1
				if totemID == 5675 or totemID == 16190 then manatotem = 1 end
				if totemID == 8835 then airtotem = 1 end
			end
			if buffed == "Drink" then
				reg = 1
			end
		end
	end
	return reg, UnitAffectingCombat(UnitID) and 1 or 0, totem, manatotem, airtotem
end

function tom_table.UnitRole(unit)
	local result = 0
	result = result + tom_table.isHealer(UnitName(unit))
	if result == 0 then
		result = result + tom_table.isTank(UnitName(unit))
	end
	return result
end

function tom_table.isHealer(playerName)
	for k, v in pairs(tom_table.Settings.Healer) do
		if playerName == v then
			return 1
		end
	end
	return 0
end

function tom_table.isTank(playerName)
	for k, v in pairs(tom_table.Settings.Tanks) do
		if playerName == v then
			return 2
		end
	end
	return 0
end

function tom_table.PlayerIsIn()
	local isin = "solo"
	if UnitInBattleground("player") and true or nil then
		isin = "bg"
	elseif IsInRaid() then
		isin = "raid"
	elseif IsInGroup() then
		isin = "party"
	end
	return isin
end

function tom_table.IsInTable(tab, key)
	if not key then return nil end
	for k, v in pairs(tab) do
		if key == v then
			return true
		end
	end
	return nil
end

function tom_table.BuildUnitID(i) -- 1 = Player or raid1, 2 party1 or raid2, ...
	local UnitID = "player"
	local isin = tom_table.PlayerIsIn()
	if isin == "party" then
		UnitID = (i == 1) and "PLAYER" or "party"..i-1
	elseif isin == "raid" or isin == "bg" then
		UnitID = "raid"..i
	end
	return UnitID

end

function tom_table.CountHealer(mod)
	local nListedHealer, nGrpHealer, nAvaHealer = 0, 0, 0
	for _ in ipairs(tom_table.Settings.Healer) do nListedHealer = nListedHealer + 1 end
	for i = 1, (GetNumGroupMembers() ~= 0 ) and GetNumGroupMembers() or 1 do
		local Unit = tom_table.BuildUnitID(i)
		if tom_table.isHealer(UnitName(Unit)) == 1 then nGrpHealer = nGrpHealer + 1	end
		if tom_table.isHealer(UnitName(Unit)) == 1 and UnitIsConnected(Unit) and not UnitIsDeadOrGhost(Unit) then nAvaHealer = nAvaHealer + 1 end
	end
	return (mod == "grp") and nGrpHealer or (mod == "list") and nListedHealer or nAvaHealer
end

function tom_table.CountTanks(mod)
	local nListedTanks, nGrpTanks, nAvaTanks = 0, 0, 0
	for _ in ipairs(tom_table.Settings.Tanks) do nListedTanks = nListedTanks + 1 end
	for i = 1, (GetNumGroupMembers() ~= 0 ) and GetNumGroupMembers() or 1 do
		local Unit = tom_table.BuildUnitID(i)
		if tom_table.isTank(UnitName(Unit)) == 2 then nGrpTanks = nGrpTanks + 1	end
		if tom_table.isTank(UnitName(Unit)) == 2 and UnitIsConnected(Unit) and not UnitIsDeadOrGhost(Unit) then nAvaTanks = nAvaTanks + 1 end
	end
	return (mod == "grp") and nGrpTanks or (mod == "list") and nListedTanks or nAvaTanks
end

function tom_table.CountGroup()
	local cGroup = GetNumGroupMembers()
	local cTanks = tom_table.CountTanks("grp")
	local cHealer = tom_table.CountHealer("grp")
	local isin = tom_table.PlayerIsIn()

        if isin == "solo" then cGroup = cGroup + 1 end
        result = cGroup - cTanks - cHealer

	--[[ if tom_table.Settings.dev then
	        print("all: ", cGroup)
		print("tanks: ", cTanks)
		print("healer: ", cHealer)
		print("damagedealer: ", result)
	end ]]

	return result, cTanks, cHealer, cGroup
end

function tom_table.EnableMouse(parent)
	parent:EnableMouse(true)
end

function tom_table.StopMouse(parent)
	parent:EnableMouse(false)
end

function tom_table.CreateMyBars(title, parent, x, y, w, h, bcr, bcg, bcb, vcr, vcg, vcb)
	local b = CreateFrame("StatusBar", title, parent)
	b:SetPoint("TOPLEFT", parent, "TOPLEFT", x, y)
	b:SetSize(w, h)
	b:SetFrameLevel(1)
	b:SetFrameStrata("LOW")
	b:SetAlpha(tom_table.Settings.bAlpha)
	b:SetStatusBarTexture("Interface\\BUTTONS\\WHITE8X8")
	b:GetStatusBarTexture():SetHorizTile(false)
	b:GetStatusBarTexture():SetVertTile(false)
	b:SetStatusBarColor(bcr, bcg, bcb, 1)

	b.bg = b:CreateTexture(nil, "LOW")
	b.bg:SetTexture("Interface\\Tooltips\\UI-Tooltip-Background")
	b.bg:SetAllPoints(true)
	b.bg:SetVertexColor(vcr, vcg, vcb, 1)

	b.value = b:CreateFontString(nil, "OVERLAY")
	b.value:SetPoint("LEFT", b, "LEFT", 4, 0)
	b.value:SetFont(tom_table.Font, tom_table.Settings.fSize, "OUTLINE")
	b.value:SetJustifyH("LEFT")
	b.value:SetJustifyV("MIDDLE")
	b.value:SetShadowOffset(1, -1)
	b.value:SetTextColor(1, 1, 1)

	b.value2 = b:CreateFontString(nil, "OVERLAY")
	b.value2:SetPoint("RIGHT", b, "RIGHT", 0, 0)
	b.value2:SetFont(tom_table.Font, tom_table.Settings.fSize, "OUTLINE")
	b.value2:SetJustifyH("LEFT")
	b.value2:SetJustifyV("MIDDLE")
	b.value2:SetShadowOffset(1, -1)
	b.value2:SetTextColor(1, 1, 1)

	b.reg = CreateFrame("Frame", title.." reg", b)
	b.reg:SetPoint("RIGHT", b, "RIGHT", h, 0)
	b.reg:SetSize(h, h)
	b.reg.texture = b.reg:CreateTexture(nil, "LOW")
	b.reg.texture:SetAllPoints(true)
	b.reg.texture:SetTexture("Interface\\ICONS\\INV_Drink_07")
	b.reg.texture.count = b.reg:CreateFontString(nil, "OVERLAY", "NumberFontNormalYellow")
	b.reg.texture.count:SetFont(tom_table.Font, tom_table.Settings.fSize, "OUTLINE")
	b.reg.texture.count:SetPoint("TOPRIGHT", b.reg.texture, "TOPRIGHT", 1, 1)
        tom_table.HideShowFrame(b.reg.texture)

	b.infight = CreateFrame("Frame", title.." infight", b)
	b.infight:SetPoint("RIGHT", b, "RIGHT", h, 0)
	b.infight:SetSize(h, h)
	b.infight.texture = b.infight:CreateTexture(nil, "LOW")
	b.infight.texture:SetAllPoints(true)
	b.infight.texture:SetTexture("Interface\\CharacterFrame\\UI-StateIcon")
        b.infight.texture:SetTexCoord(0.58, 0.90, 0.08, 0.41)
	b.infight.texture.count = b.infight:CreateFontString(nil, "OVERLAY", "NumberFontNormalYellow")
	b.infight.texture.count:SetFont(tom_table.Font, tom_table.Settings.fSize, "OUTLINE")
	b.infight.texture.count:SetPoint("TOPRIGHT", b.infight.texture, "TOPRIGHT", 1, 1)
        tom_table.HideShowFrame(b.infight.texture)

	b.totem = CreateFrame("Frame", title.." totem", b)
	b.totem:SetPoint("LEFT", b, "LEFT", -h, 0)
	b.totem:SetSize(h, h)
	b.totem.texture = b.totem:CreateTexture(nil, "LOW")
	b.totem.texture:SetAllPoints(true)
	b.totem.texture:SetTexture("Interface\\AddOns\\Tank-O-Meter\\textures\\totem.blp")
	b.totem.texture.count = b.totem:CreateFontString(nil, "OVERLAY", "NumberFontNormalYellow")
	b.totem.texture.count:SetFont(tom_table.Font, tom_table.Settings.fSize, "OUTLINE")
	b.totem.texture.count:SetPoint("TOPRIGHT", b.totem.texture, "TOPRIGHT", 1, 1)
        tom_table.HideShowFrame(b.totem.texture)
	return b
end

function tom_table.CreateLabel(parent, _x, _y, _fontType, _text, align, valign, w, h)
	local title = parent:CreateFontString (nil, "OVERLAY", _fontType)
	title:SetFont(tom_table.Font, tom_table.Settings.fSize, "OUTLINE")
	title:SetPoint("TOPLEFT", _x, _y)
	title:SetSize(w, h)
	title:SetJustifyH(align)
	title:SetJustifyV(valign)
	title:SetText(_text)
	return title
end

function tom_table.CreateMyFrame(name, parent, anchor, ax, ay, w, h)
	local f = CreateFrame("Frame", name, parent)
	f:ClearAllPoints()
	f:SetFrameStrata("LOW")
	f:SetFrameLevel(1)
	f:SetPoint(anchor, ax, ay)
	f:SetSize(w, h)
	f:SetMovable(true)
	f:SetClampedToScreen(true)
	f:SetAlpha(tom_table.Settings.bAlpha)
	return f
end

function tom_table.CPEditBox(f, tooltip) -- additionl to xml
	f.texture = f:CreateTexture(nil, "LOW")
	f.texture:SetAllPoints(true)
	f.texture:SetColorTexture(0, 0, 0, 0.3)
	f.tooltip = tooltip
	f:SetAutoFocus(false)
	f:SetJustifyH("CENTER")
	f:SetNumeric(true)
	f:SetScript("OnEnter", tom_table.OnEnterFrame)
	f:SetScript("OnLeave", tom_table.OnLeaveFrame)
	return f
end

function tom_table.CPToolTip(f, tooltip) -- additionl to xml
	f.tooltip = tooltip
	f:SetScript("OnEnter", tom_table.OnEnterFrame)
	f:SetScript("OnLeave", tom_table.OnLeaveFrame)
	return f
end

function tom_table.createEditBox(name, parent, x_loc, y_loc, w, h, displayname)
	local s = CreateFrame("ScrollFrame", nil, parent, "UIPanelScrollFrameTemplate") -- or you actual parent instead
	s:SetPoint("TOPLEFT", x_loc, y_loc)
	s:SetSize(w,h)
	s.texture = s:CreateTexture(nil, "LOW")
	s.texture:SetAllPoints(true)
	s.texture:SetColorTexture(0, 0, 0, .2)
	e = CreateFrame("EditBox", name, s)
	e:SetMultiLine(true)
	e:SetFontObject("ChatFontNormal")
	e:SetFont(tom_table.Font, tom_table.Settings.fSize)
	e:SetSize(w,h)
	s:SetScrollChild(e)
	e:SetScript("OnEnterPressed", function()
		e:ClearFocus()
	end)
	e:SetScript("OnEscapePressed", function()
		e:ClearFocus()
	end)
	return e
end

function tom_table.FrameToggle()
        tom_table.FrameStatus = tom_table.TrueFalseSwitch(tom_table.FrameStatus)
        tom_table.HideShowFrame(tom_table.frame, tom_table.FrameStatus)
	tom_table.RefreshChkboxs()
end

function tom_table.ToggleLOCK()
        tom_table.FrameLOCKstatus = tom_table.TrueFalseSwitch(tom_table.FrameLOCKstatus)
	tom_table.DragFrameMaster()
	tom_table.RefreshChkboxs()
	tom_table.CPToolTip(ToggleLOCK, tom_table.LockToolTip())
	GameTooltip:SetText(ToggleLOCK.tooltip, nil, nil, nil, nil, true)
end

function tom_table.LockToolTip()
	if tom_table.FrameLOCKstatus then
		tom_table.FrameLOCKToolTip = "is unlocked"
	else
		tom_table.FrameLOCKToolTip = "is locked"
	end
	return tom_table.FrameLOCKToolTip
end

function tom_table.BarToolTipToggle()
        tom_table.BarToolTipStatus = tom_table.TrueFalseSwitch(tom_table.BarToolTipStatus)
	tom_table.Bars()
	tom_table.RefreshChkboxs()
end

function tom_table.hlToggle()
        tom_table.hlStatus = tom_table.TrueFalseSwitch(tom_table.hlStatus)
        tom_table.HideShowFrame(tom_table.hl, tom_table.hlStatus)
end

function tom_table.DragFrame(parent)
	parent:EnableMouse(true)
	parent:RegisterForDrag("LeftButton")
	parent:SetScript("OnDragStart", parent.StartMoving)
	parent:SetScript("OnDragStop", parent.StopMovingOrSizing)
end

function tom_table.StopDragFrame(parent)
	parent:EnableMouse(false)
	parent:RegisterForDrag()
end

function tom_table.OpenLog()
	tom_table.UpdateInfoOnce(true)
end

function tom_table.ListHealer()
	local msg = nil
	table.sort(tom_table.Settings.Healer)
	for k, v in ipairs(tom_table.Settings.Healer) do
		msg = (msg == nil) and v or msg..", "..v
	end
	if msg == nil then
		tom_table.PrintMSG("no healer added")
	else
		tom_table.PrintMSG("added healer: "..msg)
	end
end

function tom_table.ListTanks()
	local msg = nil
	table.sort(tom_table.Settings.Tanks)
	for k, v in ipairs(tom_table.Settings.Tanks) do
		msg = (msg == nil) and v or msg..", "..v
	end
	if msg == nil then
		tom_table.PrintMSG("no tank added")
	else
		tom_table.PrintMSG("added tanks: "..msg)
	end
end

function tom_table.Lists()
	local msg = ""
	table.sort(tom_table.Settings.Tanks)
	for k, v in ipairs(tom_table.Settings.Tanks) do
		if v then msg = (msg == "") and v or msg.."\n"..v end
	end
	tom_table.ListsFrame.tanks:SetText(msg)

	msg = ""
	table.sort(tom_table.Settings.Healer)
	for k, v in ipairs(tom_table.Settings.Healer) do
		if v then msg = (msg == "") and v or msg.."\n"..v end
	end
	tom_table.ListsFrame.healer:SetText(msg)

	tom_table.HideShowFrame(tom_table.ListsFrame, true)
end

function tom_table.AddHealer(name)
	if tom_table.IsInTable(tom_table.Settings.Healer, name) then
		tom_table.PrintMSG("healer "..name.." is already added")
	else
		table.insert(tom_table.Settings.Healer, name)
		tom_table.PrintMSG("add healer: "..name)
	end
        if tom_table.IsInTable(tom_table.Settings.Tanks, name) then
        	tom_table.RemoveTank(name)
	end
	tom_table.Bars()
	tom_table.TAL()
	tom_table.HAL()
	tom_table.syncLists()
end

function tom_table.AddTank(name)
	if tom_table.IsInTable(tom_table.Settings.Tanks, name) then
		tom_table.PrintMSG("tank "..name.." is already added")
	else
		table.insert(tom_table.Settings.Tanks, name)
		tom_table.PrintMSG("add tank: "..name)
	end
        if tom_table.IsInTable(tom_table.Settings.Healer, name) then
        	tom_table.RemoveHealer(name)
	end
	tom_table.Bars()
	tom_table.TAL()
	tom_table.HAL()
	tom_table.syncLists()
end

function tom_table.RemoveChoice(name)
	if tom_table.isHealer(name) == 1 then
                tom_table.RemoveHealer(name)
	elseif tom_table.isTank(name) == 2 then
                tom_table.RemoveTank(name)
	else
		tom_table.PrintMSG(name.." is not listed, nothing happened")
	end
end

function tom_table.RemoveHealer(name)
	for k, v in ipairs(tom_table.Settings.Healer) do
		if name == v then
	      		table.remove(tom_table.Settings.Healer, k)
			tom_table.syncSendComm("TOMremH", v)
			tom_table.PrintMSG("removed healer: "..name)
		end
	end
	tom_table.Bars()
	tom_table.TAL()
	tom_table.HAL()
end

function tom_table.RemoveTank(name)
	for k, v in ipairs(tom_table.Settings.Tanks) do
		if name == v then
	      		table.remove(tom_table.Settings.Tanks, k)
			tom_table.syncSendComm("TOMremT", v)
			tom_table.PrintMSG("removed tank: "..name)
		end
	end

	tom_table.Bars()
	tom_table.TAL()
	tom_table.HAL()
end

function tom_table.ClearGroupedTanks()
	tom_table.PrintMSG("remove all grouped tanks")
        for i = 1, (GetNumGroupMembers() ~= 0 ) and GetNumGroupMembers() or 1 do
		local unit = tom_table.BuildUnitID(i)
		if tom_table.isTank(UnitName(unit)) == 2 then tom_table.RemoveTank(UnitName(unit)) end
	end
	tom_table.Bars()
	tom_table.TAL()
	tom_table.HAL()
end

function tom_table.ClearGroupedHealer()
	tom_table.PrintMSG("remove all grouped healer")
        for i = 1, (GetNumGroupMembers() ~= 0 ) and GetNumGroupMembers() or 1 do
		local unit = tom_table.BuildUnitID(i)
		if tom_table.isHealer(UnitName(unit)) == 1 then tom_table.RemoveHealer(UnitName(unit)) end
	end
	tom_table.Bars()
	tom_table.TAL()
	tom_table.HAL()
end

function tom_table.ClearList(opt)
	if opt == "healer" then
		tom_table.PrintMSG("remove all healer...")
		tom_table.Settings.Healer = {}
		tom_table.PrintMSG("list cleared")
	elseif opt == "tanks" then
		tom_table.PrintMSG("remove all tanks...")
		tom_table.Settings.Tanks = {}
		tom_table.PrintMSG("list cleared")
	else
                tom_table.PrintMSG("use /tometclearlist healer or /tometclearlist tanks")
	end
	tom_table.Bars()
	tom_table.TAL()
	tom_table.HAL()
end

function tom_table.Resizing()
	tom_table.frame:SetSize(tom_table.Settings.bWidth, tom_table.Settings.bHeight)
        tom_table.frame.title:SetFont(tom_table.Font, tom_table.Settings.fSize, "OUTLINE")
	tom_table.frame.title:SetSize(tom_table.Settings.bWidth, tom_table.Settings.bHeight)
	tom_table.frame:SetAlpha(tom_table.Settings.bAlpha)

	tom_table.frame.tal:SetFont(tom_table.Font, tom_table.Settings.fSize, "OUTLINE")
	tom_table.frame.tal:SetSize(tom_table.Settings.bWidth, tom_table.Settings.bHeight)

	tom_table.frame.hal:SetFont(tom_table.Font, tom_table.Settings.fSize, "OUTLINE")
	tom_table.frame.hal:SetSize(tom_table.Settings.bWidth, tom_table.Settings.bHeight)

	tom_table.statusbarTankHealth:SetSize(tom_table.Settings.bWidth, tom_table.Settings.bHeight)
	tom_table.statusbarTankHealth.value:SetFont(tom_table.Font, tom_table.Settings.fSize, "OUTLINE")
	tom_table.statusbarTankHealth.value2:SetFont(tom_table.Font, tom_table.Settings.fSize, "OUTLINE")
	tom_table.statusbarTankHealth:SetAlpha(tom_table.Settings.bAlpha)

	tom_table.statusbarHealerHealth:SetSize(tom_table.Settings.bWidth, tom_table.Settings.bHeight)
	tom_table.statusbarHealerHealth.value:SetFont(tom_table.Font, tom_table.Settings.fSize, "OUTLINE")
	tom_table.statusbarHealerHealth.value2:SetFont(tom_table.Font, tom_table.Settings.fSize, "OUTLINE")
	tom_table.statusbarHealerHealth:SetAlpha(tom_table.Settings.bAlpha)

	tom_table.statusbarHealerMana:SetSize(tom_table.Settings.bWidth, tom_table.Settings.bHeight)
	tom_table.statusbarHealerMana.value:SetFont(tom_table.Font, tom_table.Settings.fSize, "OUTLINE")
	tom_table.statusbarHealerMana.value2:SetFont(tom_table.Font, tom_table.Settings.fSize, "OUTLINE")
	tom_table.statusbarHealerMana:SetAlpha(tom_table.Settings.bAlpha)

	tom_table.statusbarGrpHealth:SetSize(tom_table.Settings.bWidth, tom_table.Settings.bHeight)
	tom_table.statusbarGrpHealth.value:SetFont(tom_table.Font, tom_table.Settings.fSize, "OUTLINE")
	tom_table.statusbarGrpHealth.value2:SetFont(tom_table.Font, tom_table.Settings.fSize, "OUTLINE")
	tom_table.statusbarGrpHealth:SetAlpha(tom_table.Settings.bAlpha)

	tom_table.statusbarGrpMana:SetSize(tom_table.Settings.bWidth, tom_table.Settings.bHeight)
	tom_table.statusbarGrpMana.value:SetFont(tom_table.Font, tom_table.Settings.fSize, "OUTLINE")
	tom_table.statusbarGrpMana.value2:SetFont(tom_table.Font, tom_table.Settings.fSize, "OUTLINE")
	tom_table.statusbarGrpMana:SetAlpha(tom_table.Settings.bAlpha)

	tom_table.TarFrame:SetSize(tom_table.Settings.bWidth, tom_table.Settings.bHeight)
        tom_table.TarFrame.title:SetFont(tom_table.Font, tom_table.Settings.fSize, "OUTLINE")
	tom_table.TarFrame.title:SetSize(tom_table.Settings.bWidth, tom_table.Settings.bHeight)
	tom_table.TarFrame:SetAlpha(tom_table.Settings.bAlpha)

	for i = 1, tom_table.TarSet.maxtar, 1 do
                tom_table.TarFrame["bar"..i]:SetSize(tom_table.Settings.bWidth, tom_table.Settings.bHeight)
		tom_table.TarFrame["bar"..i].value:SetFont(tom_table.Font, tom_table.Settings.fSize, "OUTLINE")
		tom_table.TarFrame["bar"..i].value2:SetFont(tom_table.Font, tom_table.Settings.fSize, "OUTLINE")
	end
end

function tom_table.defaultSize()
	tom_table.Settings.bWidth		= 250
	tom_table.Settings.bHeight		= 18
	tom_table.Settings.fSize		= 14
        tom_table.Settings.bAlpha               = 0.77
	tom_table.RefreshEditboxs()
        tom_table.Resizing()
	tom_table.UpdateBarRows()
end

function tom_table.ShowTOMCP()
	tom_table.HideShowFrame(tom_CP, true)
	tom_table.HideShowFrame(TOMConfigPanel, true)
	tom_table.RefreshChkboxs()
	tom_table.RefreshEditboxs()
end

function tom_table.RefreshEditboxs()
        TOMConfigPanelEditBoxTH1:SetText(tom_table.Settings.th1)
        TOMConfigPanelEditBoxTH2:SetText(tom_table.Settings.th2)
        TOMConfigPanelEditBoxBA1:SetText(tom_table.Settings.bAlpha)
        TOMConfigPanelEditBoxBS1:SetText(tom_table.Settings.bWidth)
        TOMConfigPanelEditBoxBS2:SetText(tom_table.Settings.bHeight)
        TOMConfigPanelEditBoxFS1:SetText(tom_table.Settings.fSize)
end

function tom_table.RefreshChkboxs()
	BadPullchkbx1:SetChecked	(tom_table.BPstatus and true or nil)
	BadPullchkbx2:SetChecked	(tom_table.Sound and true or nil)
	TankHealthchkbx1:SetChecked	(tom_table.THPstatus and true or nil)
	HealerHealthchkbx1:SetChecked	(tom_table.HHPstatus and true or nil)
	HealerManachkbx1:SetChecked	(tom_table.HMPstatus and true or nil)
	GrpHealthchkbx1:SetChecked	(tom_table.GHPstatus and true or nil)
	GrpManachkbx1:SetChecked	(tom_table.GMPstatus and true or nil)
	TALchkbx1:SetChecked		(tom_table.TALstatus and true or nil)
	HALchkbx1:SetChecked		(tom_table.HALstatus and true or nil)
	DEVchkbx1:SetChecked		(tom_table.Settings.dev and true or nil)
	ToggleTARHISTORY:SetChecked	(tom_table.Settings.TOHstatus and true or nil)
	ToggleLAMP:SetChecked		(tom_table.hlStatus and true or nil)
	ToggleTOM:SetChecked		(tom_table.FrameStatus and true or nil)
	ToggleLOCK:SetChecked		(tom_table.FrameLOCKstatus and true or nil)
	ToggleToolTips:SetChecked	(tom_table.BarToolTipStatus and true or nil)
	ToggleSync:SetChecked		(tom_table.SYNCstatus and true or nil)
end

function tom_table.DragFrameMaster()
	if tom_table.FrameLOCKstatus then
		tom_table.DragFrame(tom_table.frame)
		tom_table.DragFrame(tom_table.hl)
		if tom_table.Settings.TOHstatus then tom_table.DragFrame(tom_table.TarFrame) end
	else
		tom_table.StopDragFrame(tom_table.frame)
		tom_table.StopDragFrame(tom_table.hl)
		if tom_table.Settings.TOHstatus then tom_table.StopDragFrame(tom_table.TarFrame) end
	end
end

function tom_table.TrueFalseSwitch(var)
	if var then var = false else var = true end
	return var
end

function tom_table.HideShowBar(sar, state)
	if sar ~= nil then tom_table.HideShowFrame(sar, state) end
end

function tom_table.eventFrame:MODIFIER_STATE_CHANGED()
	if IsModifierKeyDown() then
		tom_table.EnableMouse(tom_table.hl)
	elseif not IsMouseButtonDown("LeftButton") then
		tom_table.StopMouse(tom_table.hl)
	end
end

function tom_table.CleanUpPartyFromList()
	if tom_table.PlayerIsIn() ~= "solo" then
		if tom_table.isHealer(UnitName("player")) == 1 then tom_table.RemoveHealer(UnitName("player")) end
		if tom_table.isTank(UnitName("player")) == 2 then tom_table.RemoveTank(UnitName("player")) end
		for i = 1, GetNumGroupMembers() do
			if tom_table.isHealer(UnitName(tom_table.PlayerIsIn() .. i)) == 1 then tom_table.RemoveHealer(UnitName(tom_table.PlayerIsIn() .. i)) end
			if tom_table.isTank(UnitName(tom_table.PlayerIsIn() .. i)) == 2 then tom_table.RemoveTank(UnitName(tom_table.PlayerIsIn() .. i)) end
		end
	end
end

--------------------------------------------------------------------------------

function tom_table.getKeysSortedByValue(tbl, sortFunction)
	local keys = {}
	for key in pairs(tbl) do table.insert(keys, key) end
	table.sort(keys, function(a, b)	return sortFunction(tbl[a], tbl[b]) end)
	return keys
end

function tom_table.eventFrame:PLAYER_LOGOUT()
	TankOMeter_Settings = tom_table.Settings
	TankOMeter_CharSettings = tom_table.CharSettings
	TankOMeter_FrameStatus = tom_table.FrameStatus
	TankOMeter_hlStatus = tom_table.hlStatus
	TankOMeter_FrameDragStatus = tom_table.FrameLOCKstatus
	TankOMeter_BarToolTip = tom_table.BarToolTipStatus
	TankOMeter_SYNCstatus = tom_table.SYNCstatus
	TankOMeter_BPstatus = tom_table.BPstatus
	TankOMeter_Sound = tom_table.Sound
	TankOMeter_THPstatus = tom_table.THPstatus
	TankOMeter_HHPstatus = tom_table.HHPstatus
	TankOMeter_HMPstatus = tom_table.HMPstatus
	TankOMeter_GHPstatus = tom_table.GHPstatus
	TankOMeter_GMPstatus = tom_table.GMPstatus
	TankOMeter_HALstatus = tom_table.HALstatus
	TankOMeter_TALstatus = tom_table.TALstatus
	TankOMeter_once = tom_table.once
end

--------------------------------------------------------------------------------

--////////////////////////////Publics///////////////////////////////////////////

function BadPullchkbx1_OnClick()
	tom_table.BPstatus = tom_table.TrueFalseSwitch(tom_table.BPstatus)
	tom_table.RefreshChkboxs()
end

function BadPullchkbx2_OnClick()
	tom_table.Sound = tom_table.TrueFalseSwitch(tom_table.Sound)
	tom_table.RefreshChkboxs()
end

function TankHealthchkbx1_OnClick()
	tom_table.THPstatus = tom_table.TrueFalseSwitch(tom_table.THPstatus)
	tom_table.RefreshChkboxs()
	tom_table.UpdateBarRows()
end

function HealerHealthchkbx1_OnClick()
	tom_table.HHPstatus = tom_table.TrueFalseSwitch(tom_table.HHPstatus)
	tom_table.RefreshChkboxs()
	tom_table.UpdateBarRows()
end

function HealerManachkbx1_OnClick()
	tom_table.HMPstatus = tom_table.TrueFalseSwitch(tom_table.HMPstatus)
	tom_table.RefreshChkboxs()
	tom_table.UpdateBarRows()
end

function GrpHealthchkbx1_OnClick()
	tom_table.GHPstatus = tom_table.TrueFalseSwitch(tom_table.GHPstatus)
	tom_table.RefreshChkboxs()
	tom_table.UpdateBarRows()
end

function GrpManachkbx1_OnClick()
	tom_table.GMPstatus = tom_table.TrueFalseSwitch(tom_table.GMPstatus)
	tom_table.RefreshChkboxs()
	tom_table.UpdateBarRows()
end

function HALchkbx1_OnClick()
	tom_table.HALstatus = tom_table.TrueFalseSwitch(tom_table.HALstatus)
        tom_table.HideShowFrame(tom_table.frame.hal, tom_table.HALstatus)
	tom_table.RefreshChkboxs()
	tom_table.UpdateBarRows()
end

function TALchkbx1_OnClick()
	tom_table.TALstatus = tom_table.TrueFalseSwitch(tom_table.TALstatus)
        tom_table.HideShowFrame(tom_table.frame.tal, tom_table.TALstatus)
	tom_table.RefreshChkboxs()
	tom_table.UpdateBarRows()
end

function DEVchkbx1_OnClick()
	tom_table.Settings.dev = tom_table.TrueFalseSwitch(tom_table.Settings.dev)
	tom_table.RefreshChkboxs()
end

function OKButton1_OnClick()
        tom_table.Settings.th1 = tonumber(TOMConfigPanelEditBoxTH1:GetText())
        tom_table.Settings.th2 = tonumber(TOMConfigPanelEditBoxTH2:GetText())
        tom_table.Settings.bAlpha = tonumber(TOMConfigPanelEditBoxBA1:GetText())
        tom_table.Settings.bWidth = tonumber(TOMConfigPanelEditBoxBS1:GetText())
        tom_table.Settings.bHeight = tonumber(TOMConfigPanelEditBoxBS2:GetText())
        tom_table.Settings.fSize = tonumber(TOMConfigPanelEditBoxFS1:GetText())

	if tom_table.Settings.bAlpha < 0 then tom_table.Settings.bAlpha = 0 end
	if tom_table.Settings.bAlpha > 1 then tom_table.Settings.bAlpha = 1 end
	if tom_table.Settings.th1 < 0 then tom_table.Settings.th1 = 0 end
	if tom_table.Settings.th1 > 100 then tom_table.Settings.th1 = 100 end
	if tom_table.Settings.th2 < 0 then tom_table.Settings.th2 = 0 end
	if tom_table.Settings.th2 > 100 then tom_table.Settings.th2 = 100 end
	if tom_table.Settings.bWidth < 100 then tom_table.Settings.bWidth = 100 end
	if tom_table.Settings.bWidth > 1000 then tom_table.Settings.bWidth = 1000 end
	if tom_table.Settings.bHeight < 10 then tom_table.Settings.bHeight = 10 end
	if tom_table.Settings.bHeight > 100 then tom_table.Settings.bHeight = 100 end
	if tom_table.Settings.fSize < 8 then tom_table.Settings.fSize = 8 end
	if tom_table.Settings.fSize > 48 then tom_table.Settings.fSize = 48 end

	tom_table.Resizing()
        tom_table.hlstate()
	tom_table.RefreshChkboxs()
        tom_table.RefreshEditboxs()
	tom_table.HideShowFrame(TOMConfigPanel)
end

function ResetPosiButton1_OnClick()
        tom_table.HideShowFrame(tom_table.frame, true)
        tom_table.FrameStatus = true
        tom_table.hlStatus = true
        tom_table.Settings.TOHstatus = true
        tom_table.FrameLOCKstatus = false
	tom_table.DragFrameMaster()
	tom_table.RefreshChkboxs()
	tom_table.UpdateBarRows()
        tom_table.frame:ClearAllPoints()
	tom_table.frame:SetPoint(tom_table.anchor, UIParent, tom_table.anchor, tom_table.defaultX, tom_table.defaultY)
        tom_table.hl:ClearAllPoints()
	tom_table.hl:SetPoint("CENTER", tom_table.frame, "CENTER", 0, 25)
        tom_table.TarFrame:ClearAllPoints()
	tom_table.TarFrame:SetPoint(tom_table.TarSet.anchor, UIParent, tom_table.TarSet.anchor, tom_table.TarSet.defaultX, tom_table.TarSet.defaultY)
end

function ResetSizeButton1_OnClick()
        tom_table.defaultSize()
end

function tom_FrameToggle()
	tom_table.FrameToggle()
	tom_table.RefreshChkboxs()
end

function tom_ToggleLAMP()
	tom_table.hlToggle()
	tom_table.RefreshChkboxs()
end

function tom_ToggleTARHISTORY()
	tom_table.ToggleTARHISTORY()
	tom_table.RefreshChkboxs()
end

function tom_ToggleToolTip()
	tom_table.BarToolTipToggle()
end

function tom_ToggleSync()
	tom_table.syncToggle()
end

function tom_ToggleLOCK()
        tom_table.ToggleLOCK()
end

function RolePollPopup_Show()
	tom_table.TOM_RoleCheck_FrameIni()
        tom_table.HideShowFrame(ButtonRolecheck, true)
        tom_table.HideShowFrame(TOM_Rolecheck_Popup, true)
        TOM_Rolecheck_Popup:SetScale(1.5)
end

function TOM_RoleCheck_Ini()
	if tom_table.GetMyRole() == nil then return end
	tom_table.syncSendComm("TOMRCINI", "RoleCheckINI")
	tom_table.syncSendComm("TOMRCIam", tom_table.GetMyRole())
        tom_table.TOM_RoleCheck_Changed()
end

function TOM_RoleCheck_Send()
	if tom_table.GetMyRole() == nil then return end
        tom_table.CharSettings.myRoleIs = tom_table.GetMyRole()
	tom_table.syncSendComm("TOMRCIam", tom_table.CharSettings.myRoleIs)
        tom_table.TOM_RoleCheck_Changed()
end

function RolePollPopup_Hide()
	if tom_table.GetMyRole() == nil then return end
	tom_table.CharSettings.myRoleIs = tom_table.GetMyRole()
	tom_table.HideShowFrame(ButtonRolecheck, true)
	tom_table.HideShowFrame(TOM_Rolecheck_Popup)
	tom_table.HideShowFrame(ButtonOK)
end

--//////////////////////////////////////////////////////////////////////////////

function round(number, decimals)
    return (("%%.%df"):format(decimals)):format(number)
end

function dump(o)
	if type(o) == 'table' then
		local s = '{ '
		for k,v in pairs(o) do
			if type(k) ~= 'number' then k = '"'..k..'"' end
			s = s .. '['..k..'] = ' .. dump(v) .. ','
		end
		return s .. '} '
	else
		return tostring(o)
	end
end

SlashCmdList["tomet"] = tom_table.ShowTOMCP
SlashCmdList["tometlock"] = tom_table.FrameDragToggle
SlashCmdList["tometaddtank"] = tom_table.AddTank
SlashCmdList["tometaddheal"] = tom_table.AddHealer
SlashCmdList["tometremove"] = tom_table.RemoveChoice
SlashCmdList["tometlisttanks"] = tom_table.ListTanks
SlashCmdList["tometlisthealer"] = tom_table.ListHealer
SlashCmdList["tometlists"] = tom_table.Lists
SlashCmdList["tometclearlist"] = tom_table.ClearList
SlashCmdList["tometpull"] = tom_table.SayPull
SlashCmdList["tometlog"] = tom_table.OpenLog