local TankOMeter, tom_table = ...

function tom_table.UnitPopup_ShowMenu(dropdownMenu, which, unit, name, userData)
	--tom_table.PrintMSG(dropdownMenu, which, unit, name, userData)
	if UIDROPDOWNMENU_MENU_LEVEL ~= 1 then return end

	UIDropDownMenu_AddSeparator()
	local info = UIDropDownMenu_CreateInfo()
	info.owner = dropdownMenu
	info.notCheckable = true
	local isin = tom_table.PlayerIsIn()

        tom_table.AddMenuButton(info, tom_table.title, tom_table.menu, dropdownMenu.name, "CENTER")

	if tom_table.isTank(dropdownMenu.name) == 0 then
        	tom_table.AddMenuButton(info, "add "..dropdownMenu.name.." to Tanks", tom_table.AddTank, dropdownMenu.name, "LEFT")
	else
        	tom_table.AddMenuButton(info, "remove "..dropdownMenu.name.." from Tanks", tom_table.RemoveTank, dropdownMenu.name, "LEFT")
	end

	if tom_table.isHealer(dropdownMenu.name) == 0 then
        	tom_table.AddMenuButton(info, "add "..dropdownMenu.name.." to Healer", tom_table.AddHealer, dropdownMenu.name, "LEFT")
	else
        	tom_table.AddMenuButton(info, "remove "..dropdownMenu.name.." from Healer", tom_table.RemoveHealer, dropdownMenu.name, "LEFT")
	end

        tom_table.AddMenuButton(info, "tank & healer lists", tom_table.Lists, "", "LEFT")

	if isin ~= "bg" and isin ~= "solo" then
	        tom_table.AddMenuButton(info, "role check", RolePollPopup_Show, "", "LEFT")
	        tom_table.AddMenuButton(info, "sync now", tom_table.syncLists, "", "LEFT")
	end

        tom_table.AddMenuButton(info, "|cFFFF0084Config|r-|cFF33FF33O|r-|cFFFF0084Panel|r", tom_table.ShowTOMCP, "", "CENTER")
	UIDropDownMenu_AddSeparator()
end

function tom_table.AddMenuButton(menu, text, func, funcopt, align)
	menu.text = text
	menu.func = function() func(funcopt) end
	menu.justifyH = align
	UIDropDownMenu_AddButton(menu, 1)
end

function tom_table.menu(name, Addon)
	local menu = {}
	local isin = tom_table.PlayerIsIn()
	table.insert(menu, { text = tom_table.title, isTitle = true })

	if tom_table.isTank(name) == 0 then
                table.insert(menu, { text = "add "..name.." to Tanks", func = function() tom_table.AddTank(name, nil) end })
	else
                table.insert(menu, { text = "remove "..name.." from Tanks", func = function() tom_table.RemoveTank(name) end })
	end

	if tom_table.isHealer(name) == 0 then
                table.insert(menu, { text = "add "..name.." to Heals", func = function() tom_table.AddHealer(name, nil) end })
	else
                table.insert(menu, { text = "remove "..name.." from Heals", func = function() tom_table.RemoveHealer(name) end })
	end
	table.insert(menu, { text = "tank & healer lists", func = function() tom_table.Lists() end })
	if isin ~= "bg" and isin ~= "solo" then
		table.insert(menu, { text = "sync now", func = function() tom_table.syncLists() end })
	end

	table.insert(menu, { text = "show/hide "..tom_table.title, func = function() tom_table.FrameToggle() end, checked = tom_table.FrameStatus })
	table.insert(menu, { text = "un-/lock "..tom_table.title, func = function() tom_table.ToggleLOCK() end, checked = tom_table.FrameLOCKstatus })
	table.insert(menu, { text = "on/off bar tooltips", func = function() tom_table.BarToolTipToggle() end, checked = tom_table.BarToolTipStatus })
        table.insert(menu, { text = "remove party / raid from lists", hasArrow = true,
		menuList = {
			{ text = "confirm", func = function() tom_table.CleanUpPartyFromList() end }
		}

	})
        table.insert(menu, { text = "remove grouped tanks from lists", hasArrow = true,
		menuList = {
			{ text = "confirm", func = function() tom_table.ClearGroupedTanks() end }
		}

	})
        table.insert(menu, { text = "remove grouped healer from lists", hasArrow = true,
		menuList = {
			{ text = "confirm", func = function() tom_table.ClearGroupedHealer() end }
		}

	})
	table.insert(menu, { text = "clear tank list", hasArrow = true,
		menuList = {
			{ text = "confirm", func = function() tom_table.ClearList("tanks") end }
		}

	})
	table.insert(menu, { text = "clear healer list", hasArrow = true,
		menuList = {
			{ text = "confirm", func = function() tom_table.ClearList("healer") end }
		}

	})

	-- Make the menu appear at the cursor:
	EasyMenu(menu, tom_table.menuFrame, "cursor", 0 , 0, "MENU")
	-- Or make the menu appear at the frame:
	-- menuFrame:SetPoint("BOTTOMRIGHT", tom_table.frame, "BOTTOMRIGHT")
	-- EasyMenu(menu, menuFrame, menuFrame, 0 , 0, "MENU")
end

function tom_table.ConfirmMenu(name)
	local menu = {
		{ text = tom_table.title, isTitle = true},
		{ text = "confirm clear list", func = function() tom_table.ClearList() end }
	}

	-- Make the menu appear at the cursor:
	EasyMenu(menu, tom_table.menuFrame, "cursor", 0 , 0, "MENU")
	-- Or make the menu appear at the frame:
	-- menuFrame:SetPoint("BOTTOMRIGHT", tom_table.frame, "BOTTOMRIGHT")
	-- EasyMenu(menu, menuFrame, menuFrame, 0 , 0, "MENU")
end